<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <script>


      // step;
      // buttons, forms, inputs, selects
      // {
      //   name: "button",
      //   attributes: {
      //     type: "submit",
      //     innerHTML: "text",
      //   }
      // }

      // {
      //   name: "input",
      //   attributes: {
      //     type: "text",
      //     placeholder: "i am input",
      //   } 
      // }

      class HTMLElement {
        constructor (classList, id) {
          this.element = null;
          this.classList = classList;
          this.id = id;
        }
        createElement (elemData) {
          this.element = document.createElement(elemData.name);
          this.element.className = this.classlist.join(' ');
          Object.keys(elemData.attributes).forEach(key => {
            this.element[key] = elemData.attributes[key];
          })
        }
        insertInToPage (container) {
          container.append(this.element);
        }
      }

      class Button extends HTMLElement {
        constructor (classList, id, text, type, clickHandler) {
          super(classList, id);
          this.text = text;
          this.type = type;
          this.clickHandler = clickHandler;
        }
        render (container) {
          this.createButton();
          this.insertInToPage(container);
          this.addClickHandler();
        }
        createButton () {
          this.createElement({
            name: 'button',
            attributes: {
              type: this.type,
              innerHTML: this.text
            }
          })
        }
        addClickHandler () {
          this.element.addEventListener('click', () => {
            this.clickHandler();
          })
        }
      }

      class Input extends HTMLElement {
        constructor (classList, id, text, placeholder) {
          super(classList, id);
          this.type = type;
          this,placeholder = placeholder;
        }
        render (container) {
          this.createElement();
          this.insertInToPage(container);
          this.addClickHandler();
        }
        createElement () {
          this.element = document.createElement('input');
          this.element.className = this.classlist.join(' ');
          this.element.type = this.type;
          this.element.placeholder = this.placeholder;
        }
      }

      // class HTMLElement {
      //   constructor(classList, id) {
      //     this.classList = classList;
      //     this.id = id;
      //     this.element = null;
      //   }
      //   createElement(elemData) {
      //     this.element = document.createElement(elemData.name);
      //     this.element.className = this.classList.join(" ");
      //     // Object.keys(elemData.attributes) => ['type', 'placeholder']
      //     Object.keys(elemData.attributes).forEach((key) => {
      //       // this.element[key] => this.element.type
      //       // elemData.attributes[key] => elemData.attributes.type
      //       this.element[key] = elemData.attributes[key];
      //     });
      //   }
      //   insertIntoPage(container) {
      //     container.append(this.element);
      //   }
      // }
      // class Button extends HTMLElement {
      //   constructor(classList, id, text, type, clickHandler) {
      //     super(classList, id);
      //     this.text = text;
      //     this.type = type;
      //     this.clickHandler = clickHandler;
      //   }
      //   render(container) {
      //     this.createButton();
      //     this.insertIntoPage(container);
      //     this.addClickHandler();
      //   }
      //   createButton() {
      //     this.createElement({
      //       name: "button",
      //       attributes: {
      //         type: this.type,
      //         innerHTML: this.text,
      //       },
      //     });
      //   }

      //   addClickHandler() {
      //     this.element.addEventListener("click", () => {
      //       this.clickHandler();
      //     });
      //   }
      // }

      // const newButton = new Button(
      //   ["btnclass"],
      //   "mainBtn",
      //   "hello",
      //   "submit",
      //   () => {}
      // );
      // newButton.render(document.body);

      // class Input extends HTMLElement {
      //   constructor(classList, id, type, placeholder) {
      //     super(classList, id);
      //     this.type = type;
      //     this.placeholder = placeholder;
      //   }
      //   render(container) {
      //     this.createElement();
      //     this.insertIntoPage(container);
      //   }
      //   createElement() {
      //     this.element = document.createElement("input");
      //     this.element.className = this.classList.join(" ");
      //     this.element.type = this.type;
      //     this.element.placeholder = this.placeholder;
      //   }
      // }
    </script>
  </body>
</html>
